---
title: PopStateEvent
slug: Web/API/PopStateEvent
tags:
  - API
  - Interface
  - Reference
---
<p id="Summary">{{APIRef("HTML DOM")}}</p>

<p><code><strong>PopStateEvent</strong></code> is an event handler for the {{Event("popstate")}} event on the window.</p>

<p>A <code>popstate</code> event is dispatched to the window every time the active history entry changes between two history entries for the same document. If the history entry being activated was created by a call to <code>history.pushState()</code> or was affected by a call to <code>history.replaceState()</code>, the <code>popstate</code> event's <code>state</code> property contains a copy of the history entry's state object.</p>

<div class="note">
<p><strong>Note</strong>: Just calling <code>history.pushState()</code> or <code>history.replaceState()</code> won't trigger a <code>popstate</code> event. The <code>popstate</code> event is only triggered by doing a browser action such as a clicking on the back button (or calling <code>history.back()</code> in JavaScript). And the event is only triggered when the user navigates between two history entries for the same document.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Browsers used to handle the <code>popstate</code> event differently on page load, but now they behave the same. Firefox never emitted a popstate event on page load. Chrome did until version 34, while Safari did until version 10.0.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">window.onpopstate = <em>funcRef</em>;
</pre>

<ul>
 <li><code>funcRef</code> is a handler function.</li>
</ul>

<h2 id="The_popstate_event">The popstate event</h2>

<p>As an example, a page at <code><var>http://example.com/example.html</var></code> running the following code will generate alerts as indicated:</p>

<pre class="brush:js">window.onpopstate = function(event) {
  alert("location: " + document.location + ", state: " + JSON.stringify(event.state));
};

history.pushState({page: 1}, "title 1", "?page=1");
history.pushState({page: 2}, "title 2", "?page=2");
history.replaceState({page: 3}, "title 3", "?page=3");
history.back(); // alerts "location: http://example.com/example.html?page=1, state: {"page":1}"
history.back(); // alerts "location: http://example.com/example.html, state: null
history.go(2);  // alerts "location: http://example.com/example.html?page=3, state: {"page":3}
</pre>

<p>Note that even though the original history entry (for <code><var>http://example.com/example.html</var></code>) has no state object associated with it, a <code>popstate</code> event is still fired when we activate that entry after the second call to <code>history.back()</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "browsing-the-web.html#popstateevent", "PopStateEvent")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>


<p>{{Compat("api.PopStateEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/DOM/Manipulating_the_browser_history">Manipulating the browser history</a></li>
 <li><a href="/en-US/docs/Web/Guide/DOM/Manipulating_the_browser_history/Example">Ajax navigation example</a></li>
</ul>
